> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Upload new virtual GPU image



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml post /cloud/v3/gpu/virtual/{project_id}/{region_id}/images
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-11T15:10:30.328297+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v3/gpu/virtual/{project_id}/{region_id}/images:
    post:
      tags:
        - GPU Virtual
      summary: Upload new virtual GPU image
      operationId: VirtualGpuImageListViewSet.post
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            description: Project ID
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            description: Region ID
            example: 7
            examples:
              - 7
            title: Region Id
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UploadVirtualGpuImageSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskIDsSerializer'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            task_id_list = client.cloud.gpu_virtual.clusters.images.upload(
                project_id=1,
                region_id=7,
                name="ubuntu-23.10-x64",
                url="http://mirror.noris.net/cirros/0.4.0/cirros-0.4.0-x86_64-disk.img",
            )
            print(task_id_list.tasks)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\ttaskIDList, err := client.Cloud.GPUVirtual.Clusters.Images.Upload(context.TODO(), cloud.GPUVirtualClusterImageUploadParams{\n\t\tProjectID: gcore.Int(1),\n\t\tRegionID:  gcore.Int(7),\n\t\tName:      \"ubuntu-23.10-x64\",\n\t\tURL:       \"http://mirror.noris.net/cirros/0.4.0/cirros-0.4.0-x86_64-disk.img\",\n\t})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", taskIDList.Tasks)\n}\n"
components:
  schemas:
    UploadVirtualGpuImageSerializer:
      properties:
        architecture:
          anyOf:
            - $ref: '#/components/schemas/ImageArchitectureTypeEnum'
            - type: 'null'
          default: x86_64
          description: 'Image architecture type: aarch64, `x86_64`'
          examples:
            - x86_64
        cow_format:
          default: false
          description: >-
            When True, image cannot be deleted unless all volumes, created from
            it, are deleted.
          example: true
          examples:
            - true
          title: Cow Format
          type: boolean
        hw_firmware_type:
          anyOf:
            - $ref: '#/components/schemas/ImageHwFirmwareTypeEnum'
            - type: 'null'
          default: null
          description: Specifies the type of firmware with which to boot the guest.
          examples:
            - bios
        name:
          description: Image name
          example: ubuntu-23.10-x64
          examples:
            - ubuntu-23.10-x64
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        os_distro:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: OS Distribution, i.e. Debian, CentOS, Ubuntu, CoreOS etc.
          title: Os Distro
        os_type:
          anyOf:
            - $ref: '#/components/schemas/ImageOsTypeEnum'
            - type: 'null'
          default: linux
          description: The operating system installed on the image. Linux by default
          examples:
            - linux
        os_version:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: OS version, i.e. 19.04 (for Ubuntu) or 9.4 for Debian
          examples:
            - '19.04'
          title: Os Version
        ssh_key:
          $ref: '#/components/schemas/SshKeyEnum'
          default: allow
          description: Permission to use a ssh key in instances
          examples:
            - allow
        tags:
          $ref: '#/components/schemas/CreateTagsSerializer'
          description: >-
            Key-value tags to associate with the resource. A tag is a key-value
            pair that can be associated with a resource, enabling efficient
            filtering and grouping for better organization and management. Both
            tag keys and values have a maximum length of 255 characters. Some
            tags are read-only and cannot be modified by the user. Tags are also
            integrated with cost reports, allowing cost data to be filtered
            based on tag keys or values.
          examples:
            - my-tag: my-tag-value
          x-stainless-terraform-configurability: computed_optional
        url:
          anyOf:
            - format: uri
              minLength: 1
              type: string
            - type: string
          description: Image URL
          examples:
            - http://mirror.noris.net/cirros/0.4.0/cirros-0.4.0-x86_64-disk.img
          title: Url
      required:
        - url
        - name
      title: UploadVirtualGpuImageSerializer
      type: object
    TaskIDsSerializer:
      properties:
        tasks:
          description: >-
            List of task IDs representing asynchronous operations. Use these IDs
            to monitor operation progress:

            - `GET /v1/tasks/{task_id}` - Check individual task status and
            details

            Poll task status until completion (`FINISHED`/`ERROR`) before
            proceeding with dependent operations.
          example:
            - d478ae29-dedc-4869-82f0-96104425f565
          examples:
            - - d478ae29-dedc-4869-82f0-96104425f565
          items:
            type: string
          title: Tasks
          type: array
      required:
        - tasks
      title: TaskIDsSerializer
      type: object
    ImageArchitectureTypeEnum:
      enum:
        - aarch64
        - x86_64
      title: ImageArchitectureTypeEnum
      type: string
    ImageHwFirmwareTypeEnum:
      enum:
        - bios
        - uefi
      title: ImageHwFirmwareTypeEnum
      type: string
    ImageOsTypeEnum:
      enum:
        - linux
        - windows
      title: ImageOsTypeEnum
      type: string
    SshKeyEnum:
      enum:
        - allow
        - deny
        - required
      title: SshKeyEnum
      type: string
    CreateTagsSerializer:
      description: >-
        A tag is a key-value pair that can be associated with a resource,

        enabling efficient filtering and grouping for better organization and
        management.

        Some tags are read-only and cannot be modified by the user.

        Tags are also integrated with cost reports, allowing cost data to be
        filtered based on tag keys or values.
      patternProperties:
        ^[^\s=]+$:
          description: >-
            Tag value. Maximum 255 characters. Cannot contain tabs, newlines,
            empty string or start/end with whitespace.
          example: my-tag-value
          examples:
            - my-tag-value
          maxLength: 255
          minLength: 1
          pattern: ^[^ \t\n\r\f\v]([^\t\n\r\f\v]*[^ \t\n\r\f\v])?$
          type: string
      propertyNames:
        description: >-
          Tag key. Maximum 255 characters. Cannot contain spaces, tabs,
          newlines, empty string or '=' character.
        examples:
          - my-tag
        maxLength: 255
        minLength: 1
      title: CreateTagsSerializer
      type: object
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````